var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.js
var src_exports = {};
__export(src_exports, {
  alterState: () => import_language_common2.alterState,
  beta: () => import_language_common2.beta,
  combine: () => import_language_common2.combine,
  dataPath: () => import_language_common2.dataPath,
  dataValue: () => import_language_common2.dataValue,
  default: () => src_default,
  each: () => import_language_common2.each,
  execute: () => execute,
  field: () => import_language_common2.field,
  fields: () => import_language_common2.fields,
  fn: () => import_language_common2.fn,
  fnIf: () => import_language_common2.fnIf,
  http: () => import_language_common2.http,
  lastReferenceValue: () => import_language_common2.lastReferenceValue,
  merge: () => import_language_common2.merge,
  request: () => request,
  sourceValue: () => import_language_common2.sourceValue
});
module.exports = __toCommonJS(src_exports);

// src/Adaptor.js
var Adaptor_exports = {};
__export(Adaptor_exports, {
  alterState: () => import_language_common2.alterState,
  beta: () => import_language_common2.beta,
  combine: () => import_language_common2.combine,
  dataPath: () => import_language_common2.dataPath,
  dataValue: () => import_language_common2.dataValue,
  each: () => import_language_common2.each,
  execute: () => execute,
  field: () => import_language_common2.field,
  fields: () => import_language_common2.fields,
  fn: () => import_language_common2.fn,
  fnIf: () => import_language_common2.fnIf,
  http: () => import_language_common2.http,
  lastReferenceValue: () => import_language_common2.lastReferenceValue,
  merge: () => import_language_common2.merge,
  request: () => request,
  sourceValue: () => import_language_common2.sourceValue
});
var import_language_common = require("@openfn/language-common");
var import_axios = __toESM(require("axios"), 1);
var import_url = require("url");
var import_path = __toESM(require("path"), 1);
var import_fs = __toESM(require("fs"), 1);
var import_language_common2 = require("@openfn/language-common");
var import_meta = {};
var __dirname = import_path.default.dirname(import_path.default.dirname((0, import_url.fileURLToPath)(import_meta.url)));
var filepath = import_path.default.join(__dirname, "package.json");
var pkg = JSON.parse(import_fs.default.readFileSync(filepath));
var { version } = pkg;
var defaultHeaders = { "User-Agent": `language-openfn-v${version}` };
function execute(...operations) {
  const initialState = {
    references: [],
    data: null
  };
  return (state) => {
    return (0, import_language_common.execute)(
      login,
      ...operations
    )({ ...initialState, ...state });
  };
}
function login(state) {
  const { configuration } = state;
  const { host, password, username } = configuration;
  return (0, import_axios.default)({
    method: "post",
    url: `${host}/api/login`,
    headers: { ...defaultHeaders },
    data: {
      session: {
        email: username,
        password
      }
    }
  }).then((response) => {
    console.log("Authentication succeeded.");
    const { jwt } = response.data;
    return { ...state, configuration: { ...configuration, host, jwt } };
  });
}
function request(options, callback) {
  return (state) => {
    const { host, jwt } = state.configuration;
    const { method, path: path2, params, data } = (0, import_language_common.expandReferences)(options)(state);
    return (0, import_axios.default)({
      method,
      headers: {
        ...defaultHeaders,
        Authorization: `Bearer ${jwt}`
      },
      url: `${host}/api/${path2}`,
      params,
      data
    }).then((response) => {
      const { data: data2 } = response;
      const nextState = (0, import_language_common.composeNextState)(state, data2);
      if (callback) {
        return callback(nextState);
      }
      return nextState;
    });
  };
}

// src/index.js
var src_default = Adaptor_exports;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  alterState,
  beta,
  combine,
  dataPath,
  dataValue,
  each,
  execute,
  field,
  fields,
  fn,
  fnIf,
  http,
  lastReferenceValue,
  merge,
  request,
  sourceValue
});
