var __defProp = Object.defineProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};

// src/Adaptor.js
var Adaptor_exports = {};
__export(Adaptor_exports, {
  alterState: () => alterState,
  beta: () => beta,
  combine: () => combine,
  dataPath: () => dataPath,
  dataValue: () => dataValue,
  each: () => each,
  execute: () => execute,
  field: () => field,
  fields: () => fields,
  fn: () => fn,
  fnIf: () => fnIf,
  http: () => http,
  lastReferenceValue: () => lastReferenceValue,
  merge: () => merge,
  request: () => request,
  sourceValue: () => sourceValue
});
import {
  execute as commonExecute,
  composeNextState,
  expandReferences
} from "@openfn/language-common";
import axios from "axios";
import { fileURLToPath } from "url";
import path, { resolve } from "path";
import fs from "fs";
import {
  alterState,
  beta,
  combine,
  dataPath,
  dataValue,
  each,
  field,
  fn,
  fnIf,
  fields,
  http,
  lastReferenceValue,
  merge,
  sourceValue
} from "@openfn/language-common";
var __dirname = path.dirname(path.dirname(fileURLToPath(import.meta.url)));
var filepath = path.join(__dirname, "package.json");
var pkg = JSON.parse(fs.readFileSync(filepath));
var { version } = pkg;
var defaultHeaders = { "User-Agent": `language-openfn-v${version}` };
function execute(...operations) {
  const initialState = {
    references: [],
    data: null
  };
  return (state) => {
    return commonExecute(
      login,
      ...operations
    )({ ...initialState, ...state });
  };
}
function login(state) {
  const { configuration } = state;
  const { host, password, username } = configuration;
  return axios({
    method: "post",
    url: `${host}/api/login`,
    headers: { ...defaultHeaders },
    data: {
      session: {
        email: username,
        password
      }
    }
  }).then((response) => {
    console.log("Authentication succeeded.");
    const { jwt } = response.data;
    return { ...state, configuration: { ...configuration, host, jwt } };
  });
}
function request(options, callback) {
  return (state) => {
    const { host, jwt } = state.configuration;
    const { method, path: path2, params, data } = expandReferences(options)(state);
    return axios({
      method,
      headers: {
        ...defaultHeaders,
        Authorization: `Bearer ${jwt}`
      },
      url: `${host}/api/${path2}`,
      params,
      data
    }).then((response) => {
      const { data: data2 } = response;
      const nextState = composeNextState(state, data2);
      if (callback) {
        return callback(nextState);
      }
      return nextState;
    });
  };
}

// src/index.js
var src_default = Adaptor_exports;
export {
  alterState,
  beta,
  combine,
  dataPath,
  dataValue,
  src_default as default,
  each,
  execute,
  field,
  fields,
  fn,
  fnIf,
  http,
  lastReferenceValue,
  merge,
  request,
  sourceValue
};
