/**
 * Execute a sequence of operations.
 * Wraps `language-common/execute`, and prepends initial state for http.
 * @example
 * execute(
 *   create('foo'),
 *   delete('bar')
 * )(state)
 * @private
 * @param {Operations} operations - Operations to be performed.
 * @returns {Operation}
 */
export function execute(...operations: Operations): Operation;
/**
 * Make a POST request
 * @public
 * @example
 *  request({method: 'get', path: '/jobs/});
 * @function
 * @param {object} options - Body, Query, Headers and Authentication parameters
 * @param {function} callback - (Optional) Callback function
 * @returns {Operation}
 */
export function request(options: object, callback: Function): Operation;
export { alterState, beta, combine, dataPath, dataValue, each, field, fn, fnIf, fields, http, lastReferenceValue, merge, sourceValue } from "@openfn/language-common";
